
(*

  Auto-automobil

  een finlov lohy Mistrovstv republiky sout
  dt a mldee v programovn.

  Vypracoval Petr Ambro (start. slo 16). 

*)

unit MainU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls, StdCtrls;

type
  TMain = class(TForm)
    Mapa: TImage;
    txtMapa: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    OD: TOpenDialog;
    btnGen: TButton;
    SD: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btnGenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    // procedura pro naten mapy
    procedure NactiMapu(f: string);
    // funkce pro zjitn dalho povelu
    function ZjistiPovel(pozice: TPoint): TPoint;

    // provizorn funkce pro hledn trasy
    procedure NajdiTrasu;
    // zjitn, zda je nekonen smyka nebo je jet monost najt cl
    function NekonecnaSmycka(posx,posy: integer): boolean;
  public
    { Public declarations }
  end;

var
  Main: TMain;

  SL: TStringList; // promenn, do kter nateme soubor s mapou
  W: integer; // ka mapy
  H: integer; // vka mapy

  start: TPoint; // startovn bod mapy
  trasa: TStringList; // zde budeme ukldat vygenerovanou trasu
  rychlost: TPoint; // vektor rychlosti auto-automobilu
  posledni: TPoint; // posledn pouit povel
  delka: integer; // dlka jednoho dku (poet hodnot na ose X)

  UzBylo: array[1..255,1..255] of boolean;

implementation

{$R *.dfm}

procedure TMain.Button1Click(Sender: TObject);
begin
  // jednoduch procedura pro zjitn nzvu
  // souboru (pouita komponenta pro otevrac dialog)
  // a vyvoln natac funkce mapy
  OD.FileName := '';
  if OD.Execute then
    txtMapa.Text := OD.FileName;
end;

procedure TMain.NactiMapu(f: string);
var
  i, j: integer; // promnn, kterou pouijeme v cyklech
  znak: char; // promnn, kam si ulome aktuln znak v dku
  radek: string; // aktuln dek
begin
  // inicializujeme StringList
  SL := TStringList.Create;

  try
    // pokusme se nast soubor s mapou do StringListu
    SL.LoadFromFile(f);
  except
    // v ppad selhn zavolme chybovou hlku a zrume naten
    MessageBox(Handle, 'Chyba pi natn souboru s mapou!', 'Chyba', MB_ICONERROR);
    exit;
  end;

  // smaeme vykreslenou mapu (pokud njak je)
  Mapa.Canvas.Brush.Color := clWhite;
  Mapa.Canvas.FillRect(Rect(0, 0, 255, 255));

  // piadme map vku podle potu dk
  Mapa.Height := SL.Count;

  SL.Insert(0, ''); // na zatek obsahu souboru vlome przdn dek,
                    // aby se nm pozdji lpe pracovalo s mapou

  delka := 0; // prvn inicializace promnn delka

  // v tomto cyklu projdeme jednotliv dky mapy
  for i := 1 to SL.Count-1 do begin
    radek := SL[i];

    // ulome dlku prvnho dku a nastavme ku map
    if i = 1 then begin
      delka := length(radek);
      Mapa.Width := delka;
    end;

    // pokud se dlka dku neshoduje s dlkou prvnho dku,
    // vyvolme chybovou hlku o nesprvnm formtu mapy
    if length(radek) <> delka then begin
      MessageBox(Handle, 'Soubor s mapou m nesprvn formt!', 'Chyba', MB_ICONERROR);
      exit;
    end;

    // te u jen projdeme jednotliv znaky v dku a vykreslme ji
    for j := 1 to length(radek) do begin
      znak := radek[j];
      // rozlime barvu na mapce podle znaku v souboru
      if znak = 'X' then
        Mapa.Canvas.Pixels[i-1,j-1] := clBlack // nepouiteln kousek
      else if znak = '.' then
        Mapa.Canvas.Pixels[i-1,j-1] := clGreen // cesta
      else if znak = ':' then
        Mapa.Canvas.Pixels[i-1,j-1] := clLime  // bezpen cesta
      else if znak = 'S' then begin
        Mapa.Canvas.Pixels[i-1,j-1] := clAqua; // startovn pozice
        start.Y := i;   // ulome Y-ov bod startovn pozice
        start.X := j;   // a taky X-ov bod...
      end else if znak = 'C' then
        Mapa.Canvas.Pixels[i-1,j-1] := clRed   // cl
      else begin
        MessageBox(Handle, 'V map se vyskytuje nesprvn znak!', 'Chyba', MB_ICONERROR);
        exit;
      end;
    end;
  end;

  // dodaten zviditelnme mapu
  Mapa.Visible := True;

  // uvolnme tlatko pro generovn trasy
  btnGen.Enabled := True;
end;

procedure TMain.Button2Click(Sender: TObject);
begin
  if trim(txtMapa.Text) = '' then exit;
  NactiMapu(txtMapa.Text);
end;

procedure TMain.btnGenClick(Sender: TObject);
(*
  POZNMKA K PROCEDUE:
  Procedura funguje na principu simulace jzdy auto-automobilu,
  take prvn zkouen pozice je pozice startovn. Nsledn jsou
  prochzeny okoln body a vyhledvna bezpen cesta, po kter
  se pak auto-auto dostv do cle.

  2. POZNMKA K PROCEDUE:
  Procedura nefunguje. :-(
*)
var
  povel: TPoint; // povel pro operace s rychlost auto-automobilu
  aktualni: TPoint; // aktuln pozice na map
begin
  // poten rychlost bude nulov
  rychlost.X := 0;
  rychlost.Y := 0;

  // poten definice poslednho povelu (0,0)
  povel.X := 0;
  povel.Y := 0;

  aktualni := start; // vchoz pozice bude shodn se startovn

  trasa := TStringList.Create; // (znovu) inicializujeme promnnou s trasou

  while true do begin
    //povel := ZjistiPovel(aktualni);
    break;
  end;

  NajdiTrasu;

  SD.FileName := '';
  if SD.Execute then begin
    try
      trasa.SaveToFile(SD.FileName);
    except
      MessageBox(Handle, 'Nelze zapsat trasu do zvolenho souboru.', 'Chyba', MB_ICONWARNING);
      exit;
    end;
    MessageBox(Handle, 'Trasa uloena.', 'Uloit trasu', MB_ICONINFORMATION);
  end;
end;

function TMain.ZjistiPovel(pozice: TPoint): TPoint;
var
  povel: TPoint;  // promnn na prbn ukldn zkouenho povelu
begin
  povel.X := 1;
  povel.Y := 0;

  // procedura pro zjitn (dalho) povelu nefunguje..

  result.X := 0;
  result.Y := 0;
end;

procedure TMain.NajdiTrasu; (* DEPRECATED *)
(*
  Tato procedura je ist testovac. Je mon,
  e sprvn hled cestu, ale dky svmu zpsobu een
  problmu je pomal (je zaloena na nhod) a nemus
  pracovat pln sprvn.
*)
var
  pozx, pozy: integer; // pozice X a Y na map
  posx, posy: integer; // posun v ose X a Y
  lastpozx, lastpozy: integer; // posledn pouit pozice
  i,j: integer; // pro vynulovn "UzBylo" promnn
begin
  trasa.Clear;
  for i := 1 to 255 do
    for j := 1 to 255 do
      UzBylo[i][j] := false;

  // definujeme startovn pozice
  pozx := start.X;
  pozy := start.Y;

  // vynulovat posledn pozice
  lastpozx := 0;
  lastpozy := 0;

  while true do begin
    posx := random(3)-1; // nhodn slo od -1 do 1
    posy := posx;
    if posx = 0 then
      while posy = 0 do
        posy := random(3)-1 // opt nhodn slo (nesm bt 0)
    else
      posy := random(3)-1; // jakkoliv nhodn slo (od -1 do 1)

    // pevrtme hodnoty poslednch pozic
    if lastpozx = -1 then
      lastpozx := 1
    else if lastpozx = 1 then
      lastpozx := -1;
    if lastpozy = -1 then
      lastpozy := 1
    else if lastpozy = 1 then
      lastpozy := -1;

    if (posx=lastpozx) and (posy=lastpozy) then continue;

    if NekonecnaSmycka(pozx,pozy) then begin
      MessageBox(Handle, 'Pokus najt cestu se nezdail, nastala nekonen smyka. :-('+#10+'Mte monost uloit st nalezen cesty.', 'Chyba', MB_ICONERROR);
      exit;
    end;

    // pokud u byla tato kombinace vyzkouena, ignorovat
    if uzbylo[posx+pozx][posy+pozy] then continue;

    // nechceme "vyjet" pln mimo mapu :-)
    if pozx+posx > delka then continue;
    if pozx+posx < 1 then continue;
    if pozy+posy > SL.Count then continue;
    if pozy+posy < 1 then continue;

    if SL[pozy+posy][pozx+posx] = 'X' then continue; // nen cesta
    if SL[pozy+posy][pozx+posx] = 'S' then continue; // zptky na start nesmme
    // dostali jsme se k cli 
    if SL[pozy+posy][pozx+posx] = 'C' then begin
      trasa.Add(inttostr(posx)+','+inttostr(posy));
      break;
    end;
    // nali jsme cestu
    if (SL[pozy+posy][pozx+posx] = '.') or (SL[pozy+posy][pozx+posx] = ':') then begin
      trasa.Add(inttostr(posx)+','+inttostr(posy));
      lastpozx := posx;
      lastpozy := posy;
      pozx := pozx+posx;
      pozy := pozy+posy;
      uzbylo[pozx,pozy] := true;
      continue;
    end; 
  end;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
  Randomize; // "promchn" nhodnch sel pi startu
end;

function TMain.NekonecnaSmycka(posx,posy: integer): boolean;
begin
  try
    result := ((SL[posy][posx+1]='X') or UzBylo[posx+1][posy]) and
              ((SL[posy][posx-1]='X') or UzBylo[posx-1][posy]) and
              ((SL[posy+1][posx]='X') or UzBylo[posx][posy+1]) and
              (((SL[posy-1][posx]='X') or UzBylo[posx][posy-1]) and
              ((SL[posy+1][posx+1]='X') or UzBylo[posx+1][posy+1]) and
              ((SL[posy-1][posx+1]='X') or UzBylo[posx+1][posy-1]) and
              ((SL[posy+1][posx-1]='X') or UzBylo[posx-1][posy+1]) and
              ((SL[posy-1][posx-1]='X') or UzBylo[posx-1][posy-1]));
  except
    result := true;
    exit;
  end;
end;

end.
